#include "StringRepos.h"
#include <stdlib.h>
#include <string.h>
#include <iostream.h>

StringRep::StringRep( int newSize )
  {
     ptr = 0;
     rep = new char*[size = newSize];
     if( ! rep )
       {
	  cerr << "StringRep: No memory for rep\n";
	  exit (1);
       }
  }

StringRep::~StringRep()
  {
     while( ptr )
	delete[] rep[--ptr];
     delete[] rep;
  }

bool StringRep::add( const char* str )
  {
     if( ptr == size )
	return 0;
     if( ! ( rep[ptr] = new char[ strlen( str )+1 ] ) )
       {
	  cerr << "StringRep::add: No memory for new str\n";
	  exit(1);
       }
     strcpy( rep[ptr], str );
     return ++ptr;
  }

bool StringRep::search( register const char* str ) const
  {
     for( register int i=ptr-1; i>-1; i-- )
       {
	  if( ! strcmp( rep[i], str ) )
	     return 1;
       }
     return 0;
  }
